unit CBRich;

interface

uses
	Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
	StdCtrls, ComCtrls, CB_Gdi, CB3Party, Ole2, OleCtl, OleCtrls, RichEdit,
   Printers;


type
	TRichEditE = class(TRichEdit)
   private
   	LastChar: Integer;
	public
		procedure CBPrint (var msg: TWPrintMes); message CB_PRINT;
      constructor Create (AOwner: TComponent);
      procedure ResetRichEdit;

	end;

procedure Register;

implementation

procedure Register;
begin
	RegisterComponents('CB3Party', [TRichEditE]);
end;

constructor TRichEditE.Create(AOwner: TComponent);
begin
	inherited Create(AOwner);
   ResetRichEdit;
end;

procedure TRichEditE.ResetRichEdit;
begin
   LastChar := 0;
end;


procedure TRichEditE.CBPrint (var msg: TWPrintMes);
var
	Range: TFormatRange;
	Rect: TRect;
	LogX : Integer;
	LogY : Integer;
	PLogX : Integer;
	PLogY : Integer;
   MaxLen: Integer;
   i: integer;
   j: integer;
   Gdi: TGdi;
begin
	Gdi := msg.CBPrint^.Gdi;
   Rect := msg.CBPrint^.Rect;

	LogX := GetDeviceCaps(Gdi.MetaDC, LOGPIXELSX);
	LogY := GetDeviceCaps(Gdi.MetaDC, LOGPIXELSY);
	PLogX := GetDeviceCaps(Printer.Handle, LOGPIXELSX);
	PLogY := GetDeviceCaps(Printer.Handle, LOGPIXELSY);

	SetMapMode (Gdi.MetaDC, MM_ISOTROPIC);
	i := Printer.PageWidth*LogX;
	j := Printer.PageHeight*LogY;
	SetWindowExtEx( Gdi.MetaDC, (i div PLogX),	(j div PLogY),nil);
	SetViewportExtEx( Gdi.MetaDC, Printer.PageWidth, Printer.PageHeight,nil);

	FillChar(Range, SizeOf(TFormatRange), 0);
	Range.hdc := Gdi.MetaDC;
	Range.hdcTarget := Gdi.MetaDC;

	Range.rc.Left :=  Rect.Left * 1440 div PLogX;
	Range.rc.Top := Rect.Top * 1440 div PLogY;
	Range.rc.Right := (Rect.Right * 1440 div PLogX);
	Range.rc.Bottom := (Rect.Bottom * 1440 div PLogY);
	Range.rcPage := Range.rc;
	Range.chrg.cpMin := LastChar;
	Range.chrg.cpMax := -1;
   MaxLen := GetTextLen;

	LastChar := SendMessage(Handle, EM_FORMATRANGE,0,LongInt(@Range));
	SendMessage(Handle, EM_DISPLAYBAND,0,LongInt(@Range.rc));
	SendMessage(Handle, EM_FORMATRANGE,0,LongInt(nil));

   if (LastChar = -1) or (LastChar >= MaxLen) then
	   msg.Result := CB_NOCONTINUE
   else
	   msg.Result := CB_CONTINUE;

end;

end.
